/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOUSE. See the GNU
 * General Public License for more details.
 *
 * You should have recieved a copy of the GNU General Public License
 * along with this program; if not write to the Free Software
 * Foundation, inc., 59 Temple Place, Suite 330, Boston MA 02111-1307
 * USA
 */

package JavaMicroBenchmark;

/**
 *
 * Java Micro Benchmark created a microbenchmark to test the performance of Java operations
 * on different platforms. Java Micro Benchmark can be used to guide optimization decisions
 * and to compare different Java implementations.
 *
 * @author: Yuriy Mikhaylovskiy  YuriyMikhaylovskiy@yahoo.com
 *
 *
 */


public class JavaMicroBenchmarkDoubleArithmetic extends JavaMicroBenchmarkResult{
        public int count = 1000000000;
		
	public void solve(int cnt){            
            double doubleResult = 1;
            double i = 1;
            long startTime = System.currentTimeMillis();
            while (i < cnt){
                doubleResult -= i++;
                doubleResult += i++;
                doubleResult *= i++;
                doubleResult /= i++;
            }
            resultTime = System.currentTimeMillis() - startTime;
            resultSpeed = (i*2.0/resultTime/1000);
            resultInfo = "Double arithmetic operations per second: "+resultSpeed+" E6";
	}

        public void solve(){
            solve(count);
	}
		

	public static void main(String[] args)	{
            JavaMicroBenchmarkDoubleArithmetic mbm = new JavaMicroBenchmarkDoubleArithmetic();
            mbm.solve();
            System.out.println(mbm.resultInfo);
	}
}
